// Copyright (C) 2006 Erik Dahlberg
// 
// This file is part of LSystem3D.
// 
// LSystem3D is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// LSystem3D is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with LSystem3D; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA




#include "fx.h"

#include "gui.h"
#include "lindenmayersystem.h"
#include "lsystem3d.h"
#include "model.h"
#include "renderingsurface.h"



/**
 * Constructor
 */
LSystem3D::LSystem3D(int argc, char *argv[])
{
    // create the FOX application object
    FXApp *application = new FXApp("LSystem3D");
    application->init(argc, argv);
    
    // create the windows
    RenderingSurface *surface = new RenderingSurface(application);
    Model model;
    LindenmayerSystem lsystem(&model);
    surface->setLSystem(&lsystem);
    new GUI(application, surface, &lsystem);
    
    application->create();
    application->run();
}



/**
 * Destructor
 */
LSystem3D::~LSystem3D()
{
}
